      *****************************************************************
      * DATE: 11/04/08 
      * VERSION: 1.1 
      *                                                         
      *   (C) COPYRIGHT International Business Machines Corp.   
      *   2011                                            
      *   All Rights Reserved                                   
      *   Licensed Materials - Property of IBM                  
      *   5725-C89                                              
      *                                                         
      *   US Government Users Restricted Rights -               
      *   Use, duplication or disclosure restricted by          
      *   GSA ADP Schedule Contract with IBM Corp.              
      *                                                         
      *                                                                       
      *            NOTICE TO USERS OF THE SOURCE CODE EXAMPLES                
      *                                                                       
      * INTERNATIONAL BUSINESS MACHINES CORPORATION PROVIDES THE SOURCE CODE  
      * EXAMPLES, BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS, AS IS          
      * WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,            
      * INCLUDING, BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF               
      * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE     
      * RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE CODE EXAMPLES,   
      * BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS, IS WITH YOU.  SHOULD     
      * ANY PART OF THE SOURCE CODE EXAMPLES PROVE DEFECTIVE, YOU (AND NOT    
      * IBM) ASSUME THE ENTIRE COST OF ALL NECESSARY SERVICING, REPAIR OR     
      * CORRECTION.  THIS PROGRAM MAY BE USED, EXECUTED, COPIED, MODIFIED     
      * AND DISTRIBUTED WITHOUT ROYALTY FOR THE PURPOSE OF DEVELOPING,        
      * MARKETING, OR DISTRIBUTING.                                           
      *                                                                       
      *                                                                       
      *****************************************************************
       IDENTIFICATION DIVISION.
       PROGRAM-ID. DLALL.
       ENVIRONMENT DIVISION.
       DATA DIVISION.

       WORKING-STORAGE SECTION.
       77  RID          PIC 9(6)  VALUE IS ZERO.
       01  BOOK-COUNTER  PIC 9(6).
       01  QTIMES       PIC 9(6).
       01  DL-RIDFLD    PIC 9(8) COMP-4.
       01  TMPID        PIC X(8).
       01  ABCODE       PIC X(4). 

       LINKAGE SECTION.
       01  DFHCOMMAREA.
           03 COMMAREA-ARR-ELE OCCURS 50 TIMES.
                 COPY RRDSFILE.
       01 RBA1 PIC S9(8) COMP.

       PROCEDURE DIVISION USING DFHCOMMAREA.
           COPY ERROR-HANDLING.

       MAIN.
           IF EIBCALEN NOT = LENGTH OF DFHCOMMAREA THEN
               EXEC CICS ABEND ABCODE('LERR')
               END-EXEC.

           EXEC CICS HANDLE CONDITION
                           NOTFND(FINISH)
                           ENDFILE(FINISH)
           END-EXEC.

           MOVE 1 TO BOOK-COUNTER.

           COMPUTE DL-RIDFLD = FUNCTION NUMVAL('01').     
           EXEC CICS STARTBR FILE('RRDSFILE')
                       RIDFLD(DL-RIDFLD)
                        RRN
                        GTEQ
                        REQID(0007)
           END-EXEC.

       FETCH-MORE.
           EXEC CICS READNEXT FILE('RRDSFILE')
                       RIDFLD(DL-RIDFLD)
                       RRN
                       INTO(FILEREC OF COMMAREA-ARR-ELE(BOOK-COUNTER))
                       REQID(0007)
           END-EXEC.

              IF EIBRESP = DFHRESP(NORMAL) THEN
                 MOVE "P" TO STAT OF COMMAREA-ARR-ELE(BOOK-COUNTER)
                 MOVE DL-RIDFLD TO TMPID
                 MOVE TMPID(5:4) TO RRN-NO OF 
                                     COMMAREA-ARR-ELE(BOOK-COUNTER)
              END-IF.
                
              ADD 1 TO BOOK-COUNTER.
              GO TO FETCH-MORE.

       FINISH.
              EXEC CICS RETURN
              END-EXEC.
