      *****************************************************************
      * DATE: 11/04/08 
      * VERSION: 1.1 
      *                                                         
      *   (C) COPYRIGHT International Business Machines Corp.   
      *   2011                                            
      *   All Rights Reserved                                   
      *   Licensed Materials - Property of IBM                  
      *   5725-C89                                              
      *                                                         
      *   US Government Users Restricted Rights -               
      *   Use, duplication or disclosure restricted by          
      *   GSA ADP Schedule Contract with IBM Corp.              
      *                                                         
      *                                                                       
      *            NOTICE TO USERS OF THE SOURCE CODE EXAMPLES                
      *                                                                       
      * INTERNATIONAL BUSINESS MACHINES CORPORATION PROVIDES THE SOURCE CODE  
      * EXAMPLES, BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS, AS IS          
      * WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,            
      * INCLUDING, BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF               
      * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE     
      * RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE CODE EXAMPLES,   
      * BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS, IS WITH YOU.  SHOULD     
      * ANY PART OF THE SOURCE CODE EXAMPLES PROVE DEFECTIVE, YOU (AND NOT    
      * IBM) ASSUME THE ENTIRE COST OF ALL NECESSARY SERVICING, REPAIR OR     
      * CORRECTION.  THIS PROGRAM MAY BE USED, EXECUTED, COPIED, MODIFIED     
      * AND DISTRIBUTED WITHOUT ROYALTY FOR THE PURPOSE OF DEVELOPING,        
      * MARKETING, OR DISTRIBUTING.                                           
      *                                                                       
      *                                                                       
      *****************************************************************
       IDENTIFICATION DIVISION.
       PROGRAM-ID. DLINS.
       ENVIRONMENT DIVISION.
       DATA DIVISION.
       WORKING-STORAGE SECTION.

       01  ABCODE       PIC X(4).
       01  DL-RIDFLD    PIC 9(8) COMP-4.
       01  TMPID        PIC 9(4) VALUE IS ZERO.
       01  ABSTIME     PIC S9(15) COMP-3.
       01  RECORD-DETAILS.
           05  FORM-DATE      PIC X(10) VALUE SPACES.
           05  DATE-TIME-SEP  PIC X VALUE " ".
           05  FORM-TIME      PIC X(8) VALUE SPACES.
           05  MSG-SEP        PIC X(3) VALUE " : ".
           05  TRN-MSG        PIC X(158) VALUE SPACES.

       LINKAGE SECTION.
       01  DFHCOMMAREA.  
           COPY RRDSFILE.

       PROCEDURE DIVISION USING DFHCOMMAREA.
           COPY ERROR-HANDLING.

       MAIN.
           IF EIBCALEN NOT = LENGTH OF DFHCOMMAREA THEN
               EXEC CICS ABEND ABCODE('LERR')
               END-EXEC.
             
           COMPUTE TMPID = FUNCTION NUMVAL(RRN-NO).
           MOVE TMPID TO DL-RIDFLD.

           EXEC CICS WRITE FILE('RRDSFILE') RRN
                           FROM(FILEREC)
                           LENGTH(LENGTH OF FILEREC)
                           RIDFLD(DL-RIDFLD)
           END-EXEC.

           EXEC CICS ASKTIME
                     ABSTIME    (ABSTIME)
           END-EXEC.

           EXEC CICS FORMATTIME
                     ABSTIME(ABSTIME)
                     DATESEP('-')
                     DDMMYYYY(FORM-DATE)
                     TIME(FORM-TIME)
                     TIMESEP
           END-EXEC.
           
           STRING "Added book with ID : " 
                  TMPID 
                  " and Name : "
                  BOOKNAME
                  DELIMITED BY SIZE
                  INTO TRN-MSG
           END-STRING.
           EXEC CICS WRITE FILE('ESDSFILE') 
                           FROM(RECORD-DETAILS)
                           RIDFLD(DL-RIDFLD)
                           RBA
           END-EXEC.

       END-PROGRAM.
           EXEC CICS RETURN
           END-EXEC. 
