      *****************************************************************
      * DATE: 11/04/19 
      * VERSION: 1.2 
      *                                                         
      *   (C) COPYRIGHT International Business Machines Corp.   
      *   2011                                            
      *   All Rights Reserved                                   
      *   Licensed Materials - Property of IBM                  
      *   5725-C89                                              
      *                                                         
      *   US Government Users Restricted Rights -               
      *   Use, duplication or disclosure restricted by          
      *   GSA ADP Schedule Contract with IBM Corp.              
      *                                                         
      *                                                                       
      *            NOTICE TO USERS OF THE SOURCE CODE EXAMPLES                
      *                                                                       
      * INTERNATIONAL BUSINESS MACHINES CORPORATION PROVIDES THE SOURCE CODE  
      * EXAMPLES, BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS, AS IS          
      * WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,            
      * INCLUDING, BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF               
      * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE     
      * RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE CODE EXAMPLES,   
      * BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS, IS WITH YOU.  SHOULD     
      * ANY PART OF THE SOURCE CODE EXAMPLES PROVE DEFECTIVE, YOU (AND NOT    
      * IBM) ASSUME THE ENTIRE COST OF ALL NECESSARY SERVICING, REPAIR OR     
      * CORRECTION.  THIS PROGRAM MAY BE USED, EXECUTED, COPIED, MODIFIED     
      * AND DISTRIBUTED WITHOUT ROYALTY FOR THE PURPOSE OF DEVELOPING,        
      * MARKETING, OR DISTRIBUTING.                                           
      *                                                                       
      *                                                                       
      *****************************************************************
       IDENTIFICATION DIVISION.
       PROGRAM-ID. DLLOG.
       ENVIRONMENT DIVISION.
       DATA DIVISION.

       WORKING-STORAGE SECTION.
       77  RID          PIC 9(6)  VALUE IS ZERO.
       01  BOOK-COUNTER  PIC 9(6).
       01  QTIMES       PIC 9(6).
       01  DL-RIDFLD    PIC 9(8) COMP-4.
       01  TMPID        PIC X(8).
       01  ABCODE       PIC X(4). 
       01  LENREC       PIC 9(3).

       LINKAGE SECTION.
       01  DFHCOMMAREA.
           03 RECA OCCURS 10 TIMES.
              05  STAT             PIC X.
              05  RBN-LOG          PIC X(4).
              05  RECD             PIC X(180).

       PROCEDURE DIVISION USING DFHCOMMAREA.
           COPY ERROR-HANDLING.

       MAIN.
           IF EIBCALEN NOT = LENGTH OF DFHCOMMAREA THEN
               EXEC CICS ABEND ABCODE('LERR')
               END-EXEC.

           EXEC CICS HANDLE CONDITION
                           NOTFND(END-FETCH)
                           ILLOGIC(END-FETCH)
                           ENDFILE(END-FETCH)
           END-EXEC.

           MOVE 1 TO BOOK-COUNTER.

           DIVIDE EIBCALEN BY LENGTH OF RECA(1) 
                                              GIVING QTIMES.

           IF RBN-LOG OF RECA(BOOK-COUNTER) = '0000' THEN
                EXEC CICS STARTBR FILE('ESDSFILE')
                     RIDFLD(DL-RIDFLD)
                     RBA
                END-EXEC
                EXEC CICS READNEXT FILE('ESDSFILE')
                      RIDFLD(DL-RIDFLD)
                      RBA
                      INTO(RECD OF RECA(BOOK-COUNTER))
                END-EXEC
                EXEC CICS ENDBR FILE('ESDSFILE')
                END-EXEC
            ELSE
                COMPUTE DL-RIDFLD = FUNCTION 
                      NUMVAL(RBN-LOG OF RECA(BOOK-COUNTER))
           END-IF.

       FETCH-MORE.
           EXEC CICS READ FILE('ESDSFILE')
                       RIDFLD(DL-RIDFLD)
                       RBA
                       INTO(RECD OF RECA(BOOK-COUNTER))
           END-EXEC.

              IF EIBRESP = DFHRESP(NORMAL) THEN
                 MOVE "P" TO STAT OF RECA(BOOK-COUNTER)
                 MOVE DL-RIDFLD TO TMPID
                 MOVE TMPID(5:4) TO RBN-LOG OF 
                                     RECA(BOOK-COUNTER)
              END-IF.
                
              IF BOOK-COUNTER >= QTIMES 
                  MOVE "R" TO STAT OF RECA(1)
                  GO TO FINISH
              END-IF.

               ADD 1 TO BOOK-COUNTER.
               ADD 1 TO DL-RIDFLD.

               GO TO FETCH-MORE.

       END-FETCH.
               IF BOOK-COUNTER = 1
                   MOVE SPACES TO DFHCOMMAREA
               END-IF.

                    MOVE "Z" TO STAT OF RECA(1)
                    GO TO FINISH.

       FINISH.
              EXEC CICS RETURN
              END-EXEC.
