      *****************************************************************
      * DATE: 11/05/07 
      * VERSION: 1.3 
      *                                                         
      *   (C) COPYRIGHT International Business Machines Corp.   
      *   2011                                            
      *   All Rights Reserved                                   
      *   Licensed Materials - Property of IBM                  
      *   5725-C89                                              
      *                                                         
      *   US Government Users Restricted Rights -               
      *   Use, duplication or disclosure restricted by          
      *   GSA ADP Schedule Contract with IBM Corp.              
      *                                                         
      *                                                                       
      *            NOTICE TO USERS OF THE SOURCE CODE EXAMPLES                
      *                                                                       
      * INTERNATIONAL BUSINESS MACHINES CORPORATION PROVIDES THE SOURCE CODE  
      * EXAMPLES, BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS, AS IS          
      * WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,            
      * INCLUDING, BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF               
      * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE     
      * RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE CODE EXAMPLES,   
      * BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS, IS WITH YOU.  SHOULD     
      * ANY PART OF THE SOURCE CODE EXAMPLES PROVE DEFECTIVE, YOU (AND NOT    
      * IBM) ASSUME THE ENTIRE COST OF ALL NECESSARY SERVICING, REPAIR OR     
      * CORRECTION.  THIS PROGRAM MAY BE USED, EXECUTED, COPIED, MODIFIED     
      * AND DISTRIBUTED WITHOUT ROYALTY FOR THE PURPOSE OF DEVELOPING,        
      * MARKETING, OR DISTRIBUTING.                                           
      *                                                                       
      *                                                                       
      * A simple program to check CICS LINK API Functionality.
      * This program can handle the COMMAREA from 0 to 32767
      * This program pass the data received from client 
      * to the LINKED program  
      *****************************************************************
        IDENTIFICATION DIVISION.
        PROGRAM-ID.   LINK.
        ENVIRONMENT DIVISION.
        DATA DIVISION.

        WORKING-STORAGE SECTION.
        01 TEXT-OUT    PIC X(15) VALUE 'LINK PROGRAM'.
        01  RESP-MSG   PIC S9(8)    BINARY.

        LINKAGE SECTION.
        01 DFHCOMMAREA.
           03 OCCURS 0 TO 32767 TIMES DEPENDING ON EIBCALEN PIC X(1).

        PROCEDURE DIVISION.

           IF EIBCALEN EQUAL 0
               DISPLAY TEXT-OUT
               DISPLAY "COMMAREA LENGTH IS ZERO"
           ELSE
              DISPLAY TEXT-OUT "COMMAREA: " DFHCOMMAREA
           END-IF.

           EXEC CICS LINK PROGRAM('LINKED')
                              RESP(RESP-MSG)
                              COMMAREA(DFHCOMMAREA)
                              LENGTH(EIBCALEN)
           END-EXEC.

           IF RESP-MSG NOT = DFHRESP(NORMAL) THEN
                DISPLAY "LINK FAILED"
                IF EIBCALEN NOT = 0
                    MOVE "LINK invocation FAILED." TO DFHCOMMAREA
                END-IF
           ELSE
                DISPLAY "LINK SUCCESSFUL"
                IF EIBCALEN NOT = 0
                    MOVE "LINK invocation is successful." TO DFHCOMMAREA
                END-IF
           END-IF.

           EXEC CICS RETURN
           END-EXEC.

