      *****************************************************************
      * DATE: 11/04/05
      * VERSION: 1.5
      *                                                         
      *   (C) COPYRIGHT International Business Machines Corp.   
      *   2011                                            
      *   All Rights Reserved                                   
      *   Licensed Materials - Property of IBM                  
      *   5725-C89                                              
      *                                                         
      *   US Government Users Restricted Rights -               
      *   Use, duplication or disclosure restricted by          
      *   GSA ADP Schedule Contract with IBM Corp.              
      *                                                         
      *                                                                       
      *            NOTICE TO USERS OF THE SOURCE CODE EXAMPLES                
      *                                                                       
      * INTERNATIONAL BUSINESS MACHINES CORPORATION PROVIDES THE SOURCE CODE  
      * EXAMPLES, BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS, AS IS          
      * WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,            
      * INCLUDING, BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF               
      * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE     
      * RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE CODE EXAMPLES,   
      * BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS, IS WITH YOU.  SHOULD     
      * ANY PART OF THE SOURCE CODE EXAMPLES PROVE DEFECTIVE, YOU (AND NOT    
      * IBM) ASSUME THE ENTIRE COST OF ALL NECESSARY SERVICING, REPAIR OR     
      * CORRECTION.  THIS PROGRAM MAY BE USED, EXECUTED, COPIED, MODIFIED     
      * AND DISTRIBUTED WITHOUT ROYALTY FOR THE PURPOSE OF DEVELOPING,        
      * MARKETING, OR DISTRIBUTING.                                           
      *                                                                       
      *                                                                       
      *****************************************************************
      *    DFHALL - CICS SAMPLE TO VIEW ALL EMPLOYEE RECORDS          *
      *****************************************************************
       IDENTIFICATION DIVISION.
       PROGRAM-ID. DFHALL.
       ENVIRONMENT DIVISION.
       DATA DIVISION.
       WORKING-STORAGE SECTION.
       77  RID          PIC 9(6)  VALUE IS ZERO.
       01  EMP-COUNTER  PIC 9(6)  VALUE IS 1.
       01  QTIMES       PIC 9(6).
       01  RECFETCHED   PIC 9(6).
       01  FILEA.       COPY DFHCFIL.
       01  ABCODE       PIC X(4) VALUE SPACES.

       LINKAGE SECTION.
       01  DFHCOMMAREA.
           05 COMMAREA-ARR-ELE OCCURS 10 TIMES.
              10  ESTAT           PIC X.       
      *  ESTAT filed used as protocol in application for displaying the employee records
              10  ENUMB           PIC X(6).
              10  ENAMEX          PIC X(20).
              10  EADDRX          PIC X(20).
              10  EPHONE          PIC X(10).
              10  EDATEX          PIC X(10).
              10  EAMOUNT         PIC X(8).
              10  ECOMMENT        PIC X(21).

       PROCEDURE DIVISION USING DFHCOMMAREA.
           COPY ERROR-HANDLING.
       MAIN.

           IF EIBCALEN NOT = LENGTH OF DFHCOMMAREA THEN
               EXEC CICS ABEND ABCODE('LERR')
               END-EXEC.

           EXEC CICS HANDLE CONDITION
                           NOTFND(END-FETCH)
                           ENDFILE(END-FETCH)
           END-EXEC.

           MOVE ENUMB OF COMMAREA-ARR-ELE(1) TO RID.

           DIVIDE EIBCALEN BY LENGTH OF FILEREC GIVING QTIMES.
           EXEC CICS STARTBR DATASET('FILEA')
                             RIDFLD(RID)
                             KEYLENGTH(LENGTH OF ENUMB)
                             GTEQ
                             END-EXEC.
       FETCH-MORE.
               EXEC CICS READNEXT INTO(FILEA)
                              DATASET('FILEA')
                              RIDFLD(RID)
                              END-EXEC.

               MOVE "P"   TO ESTAT OF COMMAREA-ARR-ELE(EMP-COUNTER).
               MOVE NUMB   TO ENUMB OF COMMAREA-ARR-ELE(EMP-COUNTER).
               MOVE NAMEX   TO ENAMEX OF COMMAREA-ARR-ELE(EMP-COUNTER).
               MOVE ADDRX   TO EADDRX OF COMMAREA-ARR-ELE(EMP-COUNTER).
               MOVE PHONE   TO EPHONE OF COMMAREA-ARR-ELE(EMP-COUNTER).
               MOVE DATEX   TO EDATEX OF COMMAREA-ARR-ELE(EMP-COUNTER).
               MOVE AMOUNT  TO EAMOUNT OF COMMAREA-ARR-ELE(EMP-COUNTER).
               MOVE COMMENT TO ECOMMENT OF COMMAREA-ARR-ELE(EMP-COUNTER).

               IF EMP-COUNTER >= QTIMES 
                   MOVE "R" TO ESTAT OF COMMAREA-ARR-ELE(1)
                   GO TO FINISH
               END-IF.

               ADD 1 TO EMP-COUNTER.
               GO TO FETCH-MORE.

       END-FETCH.
               IF EMP-COUNTER = 1 
                   MOVE SPACES TO DFHCOMMAREA
               END-IF.
               MOVE "Z" TO ESTAT OF COMMAREA-ARR-ELE(1).
               GO TO FINISH.

       FINISH.
           EXEC CICS RETURN
           END-EXEC.
