      ***************************************************************
      *****************************************************************
      * DATE: 10/11/09
      * VERSION: 1.2
      *                                                         
      *   (C) COPYRIGHT International Business Machines Corp.   
      *   2011                                            
      *   All Rights Reserved                                   
      *   Licensed Materials - Property of IBM                  
      *   5725-C89                                              
      *                                                         
      *   US Government Users Restricted Rights -               
      *   Use, duplication or disclosure restricted by          
      *   GSA ADP Schedule Contract with IBM Corp.              
      *                                                         
      *                                                                       
      *            NOTICE TO USERS OF THE SOURCE CODE EXAMPLES                
      *                                                                       
      * INTERNATIONAL BUSINESS MACHINES CORPORATION PROVIDES THE SOURCE CODE  
      * EXAMPLES, BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS, AS IS          
      * WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,            
      * INCLUDING, BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF               
      * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE     
      * RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE CODE EXAMPLES,   
      * BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS, IS WITH YOU.  SHOULD     
      * ANY PART OF THE SOURCE CODE EXAMPLES PROVE DEFECTIVE, YOU (AND NOT    
      * IBM) ASSUME THE ENTIRE COST OF ALL NECESSARY SERVICING, REPAIR OR     
      * CORRECTION.  THIS PROGRAM MAY BE USED, EXECUTED, COPIED, MODIFIED     
      * AND DISTRIBUTED WITHOUT ROYALTY FOR THE PURPOSE OF DEVELOPING,        
      * MARKETING, OR DISTRIBUTING.                                           
      *                                                                       
      *                                                                       
      *****************************************************************
      *****************************************************************
      *    LOGIN - CICS SAMPLE LOGIN IN SHOPPING MALL - COBOL         *
      *****************************************************************

       IDENTIFICATION DIVISION.                                                 
       PROGRAM-ID.    LOGIN.                                                  
       ENVIRONMENT DIVISION.                                                    
       INPUT-OUTPUT SECTION.                                                    
       FILE-CONTROL.                                                            
       DATA DIVISION.                                                           
       FILE SECTION.                                                            
       WORKING-STORAGE SECTION.                                                 
       01  WS-CF-AREA.                                                          
           05  WS-TSQ-NAME.                                                     
               10  WS-TSQ-TRNID   PIC X(04).                                    
               10  WS-TSQ-TRMID   PIC X(04).                                    
           05  WS-TSQ-LENGTH      PIC S9(4) COMP.                               
           05  WS-TSQ-ITEM        PIC S9(4) COMP.                               
           05  WS-TSQ-COUNT       PIC 99.                                       
           05  WS-TSQ-RECORD      PIC X(128).                                   
       01 W-SUCCESS   PIC X VALUE SPACE.                                        
       01 W-RESP      PIC S9(8) COMP.                                           
       01 ESM-RESP    PIC S9(8) COMP.                                           
       01 RESPONSE    PIC S9(8) COMP-4 VALUE 0.                                 
       01  ABCODE       PIC X(4) VALUE SPACES.
       01 CICSUSER    PIC X(8) VALUE 'CICSUSER'.                                
       01 BLANKS      PIC X(8) VALUE '        '.                                
       01 REASON-CODE PIC S9(8) COMP-4 VALUE 0.                                 
       01 W-CTR       PIC 99.                                                   
       01 USER-REC.                                                             
          05  USER-SHOP  PIC XX.                                                
          05  USER-ID    PIC X(8).                                              
          05  USER-PASSWD PIC X(12).                                            
          05  USER-REST   PIC X(50).                                            
       01  CO-REC.                         
           05 CO-CODE             PIC X(2). 
           05 CO-NAME             PIC X(50).
           05 CO-ADD1             PIC X(40). 
           05 CO-ADD2             PIC X(40). 
           05 CO-ADD3             PIC X(40). 
           05 CO-ADD4             PIC X(40). 
           05 CO-PIN              PIC X(6).  
           05 CO-IT-NO            PIC X(40). 
           05 CO-ST-NO            PIC X(40). 
           05 CO-SST-NO           PIC X(40). 
           05 CO-OTH-TAX1         PIC X(40). 
           05 CO-OTH-TAX2         PIC X(40). 
           05 CO-OTH-TAX3         PIC X(40). 
           05 CO-FIN-YEAR-FROM    PIC X(10). 
           05 CO-BOOKS-FROM       PIC X(10). 
           05 CO-BARCODE-PRINTER  PIC X(4).
           05 FILLER              PIC X(30).
       01  SUB         PIC 99.                                                  
       01 DFHCOMM.                                                              
          05  DFHCOMMX   PIC X.                                                 
          05  W-EXTRA    PIC X(10).                                             
      *  CLST - Get list of Companies
      *  Input
      *      LGN-COMMAND value 'CLST' 
      *  Output 
      *      LGN-COCODE  
      *      LGN-CONAME  
      * 
      *  LOGN - Login 
      *  Input 
      *      LGN-UID, LGN-SHOP, LGN-PASSWD 
      *  Optional input 
      *      LGN-NEWPASSWD, LGN-CONFPASSWD 
      *  Output 
      *      LGN-RESP = 0 if success or else non-zero 
      * 
      * 
       LINKAGE SECTION.                                                         
       01  DFHCOMMAREA.
           05  LGN-COMMAND     PIC X(4).
           05  LGN-UID         PIC X(8).
           05  LGN-SHOP        PIC XX.
           05  LGN-PASSWD      PIC X(12).
           05  LGN-NEWPASSWD   PIC X(12).
           05  LGN-CONFPASSWD  PIC X(12).
           05  LGN-MESG        PIC X(50).
           05  LGN-FUNKEY      PIC S9(4) COMP.
           05  LGN-RESP        PIC S9(4) COMP.
           05  LGN-CO-DETAILS OCCURS 50.
               10  LGN-COCODE  PIC X(2).
               10  LGN-CONAME  PIC X(50).
       PROCEDURE DIVISION.                                                      
       ERROR-HANDLING-PARA.
           COPY "ERROR-HANDLING".
       MAIN-PARA.                                                               
           IF LGN-COMMAND = "CLST"
              MOVE 0 TO W-RESP
              MOVE SPACES TO CO-CODE
              EXEC CICS IGNORE CONDITION NOTFND END-EXEC
              PERFORM VARYING SUB FROM 1 BY 1 UNTIL LGN-RESP NOT = 0
                  EXEC CICS READ FILE('COFILE')
                            INTO(CO-REC)
                            RIDFLD(CO-CODE)
                            LENGTH(LENGTH OF CO-REC)
                            EQUAL
      *                     RESP(W-RESP)
                  END-EXEC
                  IF EIBRESP = DFHRESP(NORMAL)
                     MOVE CO-CODE TO LGN-COCODE(SUB)
                     MOVE CO-NAME TO LGN-CONAME(SUB)
                  ELSE
                     IF SUB = 1
                        MOVE -1 TO LGN-RESP
                     END-IF
                  END-IF
               END-PERFORM
           END-IF.
           IF LGN-COMMAND = "LOGN"
              PERFORM LOGON-PROCESS
           END-IF.
           EXEC CICS RETURN END-EXEC.
       LOGON-PROCESS.
           MOVE LGN-SHOP TO W-EXTRA.                                           
           MOVE LGN-UID TO W-EXTRA(3:).                                        
           IF LGN-NEWPASSWD NOT = "  "                                         
              EXEC CICS IGNORE CONDITION NOTFND END-EXEC
              EXEC CICS READ FILE('USERFILE')                                   
                        INTO(USER-REC)                                          
                        RIDFLD(W-EXTRA)                                         
                        EQUAL                                                   
      *                 RESP(W-RESP)                                            
                        UPDATE                                                  
              END-EXEC                                                          
              IF EIBRESP = 0                                                 
                 IF LGN-PASSWD = USER-PASSWD                                   
                    IF LGN-NEWPASSWD = LGN-CONFPASSWD                         
                       PERFORM SIGNON-CHANGEPWD                                 
                       MOVE LGN-NEWPASSWD TO USER-PASSWD                       
                                              LGN-PASSWD                       
                       EXEC CICS REWRITE FILE('USERFILE')                       
                                 FROM(USER-REC)                                 
                       END-EXEC                                                 
                    ELSE                                                        
                       MOVE 'SET OF NEW PASSWORDS DO NOT MATCH' TO              
                            LGN-MESG                                           
                       MOVE -1 TO LGN-RESP
                    END-IF                                                      
                 ELSE                                                           
                    MOVE 'N' TO W-SUCCESS                                       
                    MOVE 'INVALID USERID AND PASSWORD' TO                       
                         LGN-MESG                                              
                         MOVE -1 TO LGN-RESP
                 END-IF                                                         
              ELSE                                                              
                 MOVE 'N' TO W-SUCCESS                                          
                 MOVE 'INVALID USERID AND PASSWORD' TO                          
                      LGN-MESG                                                 
                 MOVE -1 TO LGN-RESP
              END-IF                                                            
           ELSE                                                                 
              EXEC CICS IGNORE CONDITION NOTFND END-EXEC
              EXEC CICS READ FILE('USERFILE')                                   
                        INTO(USER-REC)                                          
                        RIDFLD(W-EXTRA)                                         
                        EQUAL                                                   
      *                 RESP(W-RESP)                                            
              END-EXEC                                                          
           END-IF.                                                              
           IF EIBRESP = 0                                                       
              IF USER-PASSWD = LGN-PASSWD                                      
                 MOVE 'Y' TO W-SUCCESS                                          
                 PERFORM ONLY-SIGNON                                            
              ELSE                                                              
                 MOVE 'N' TO W-SUCCESS                                          
                 MOVE 'INVALID USERID AND PASSWORD' TO                          
                      LGN-MESG                                                 
                 MOVE -1 TO LGN-RESP
              END-IF                                                            
           ELSE IF LGN-SHOP = 'TX' AND LGN-UID = 'KAILAS' AND                 
                   LGN-PASSWD = 'HSENAGSHETYE'                                 
                   MOVE LGN-SHOP TO USER-SHOP                                  
                   MOVE LGN-UID  TO USER-ID                                    
                   MOVE 'Y' TO W-SUCCESS                                        
                ELSE                                                            
                   MOVE 'N' TO W-SUCCESS                                        
                   MOVE 'INVALID USERID AND PASSWORD' TO                        
                        LGN-MESG                                               
                   MOVE -1 TO LGN-RESP
                END-IF                                                          
           END-IF.                                                              
       MISCELLANEOUS SECTION.                                                   
       SIGNON-CHANGEPWD.                                                        
           EXEC CICS SIGNOFF                                                    
                     RESP(W-RESP)                                               
           END-EXEC.                                                            
           EXEC CICS SIGNON                                                     
                     USERID(LGN-UID)                                           
                     PASSWORD(USER-PASSWD)                                      
                     NEWPASSWORD(LGN-NEWPASSWD)                                
                     RESP(W-RESP)                                               
                     ESMRESP(ESM-RESP)                                          
           END-EXEC.                                                            
           IF ESM-RESP = 0 AND W-RESP = 0                                       
              NEXT SENTENCE                                                     
           ELSE                                                                 
              EXEC CICS SIGNON                                                  
                        USERID(CICSUSER)                                        
                        PASSWORD(BLANKS)                                        
                        RESP(W-RESP)                                            
                        ESMRESP(ESM-RESP)                                       
              END-EXEC                                                          
              IF ESM-RESP NOT = 0 AND W-RESP NOT = 0                            
                 EXEC CICS RETURN END-EXEC                                      
              END-IF                                                            
           END-IF.                                                              
       ONLY-SIGNON.                                                             
           EXEC CICS SIGNOFF                                                    
                     RESP(W-RESP)                                               
           END-EXEC.                                                            
           EXEC CICS SIGNON                                                     
                     USERID(LGN-UID)                                           
                     PASSWORD(USER-PASSWD)                                      
                     RESP(W-RESP)                                               
                     ESMRESP(ESM-RESP)                                          
           END-EXEC.                                                            
           IF ESM-RESP = 0 AND W-RESP = 0                                       
              NEXT SENTENCE                                                     
           ELSE                                                                 
              EXEC CICS SIGNON                                                  
                        USERID(CICSUSER)                                        
                        PASSWORD(BLANKS)                                        
                        RESP(W-RESP)                                            
                        ESMRESP(ESM-RESP)                                       
              END-EXEC                                                          
              IF ESM-RESP NOT = 0 AND W-RESP NOT = 0                            
                 EXEC CICS RETURN END-EXEC                                      
              END-IF                                                            
           END-IF.                                                              
                                                                                
