      ***************************************************************
      *****************************************************************
      * DATE: 11/04/14
      * VERSION: 1.4
      *                                                         
      *   (C) COPYRIGHT International Business Machines Corp.   
      *   2011                                            
      *   All Rights Reserved                                   
      *   Licensed Materials - Property of IBM                  
      *   5725-C89                                              
      *                                                         
      *   US Government Users Restricted Rights -               
      *   Use, duplication or disclosure restricted by          
      *   GSA ADP Schedule Contract with IBM Corp.              
      *                                                         
      *                                                                       
      *            NOTICE TO USERS OF THE SOURCE CODE EXAMPLES                
      *                                                                       
      * INTERNATIONAL BUSINESS MACHINES CORPORATION PROVIDES THE SOURCE CODE  
      * EXAMPLES, BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS, AS IS          
      * WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,            
      * INCLUDING, BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF               
      * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE     
      * RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE CODE EXAMPLES,   
      * BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS, IS WITH YOU.  SHOULD     
      * ANY PART OF THE SOURCE CODE EXAMPLES PROVE DEFECTIVE, YOU (AND NOT    
      * IBM) ASSUME THE ENTIRE COST OF ALL NECESSARY SERVICING, REPAIR OR     
      * CORRECTION.  THIS PROGRAM MAY BE USED, EXECUTED, COPIED, MODIFIED     
      * AND DISTRIBUTED WITHOUT ROYALTY FOR THE PURPOSE OF DEVELOPING,        
      * MARKETING, OR DISTRIBUTING.                                           
      *                                                                       
      *                                                                       
      *****************************************************************
      *****************************************************************
      *    TRANS - CICS SAMPLE SOURCE - TRANSACTION IN SM - COBOL   *
      *****************************************************************
       IDENTIFICATION DIVISION.                                         
       PROGRAM-ID.    TRANS1.                                          
      * program migrated for WXTR
       ENVIRONMENT DIVISION.                                            
       INPUT-OUTPUT SECTION.                                            
       FILE-CONTROL.                                                   
       DATA DIVISION.                                                  
       FILE SECTION.                                                  
       WORKING-STORAGE SECTION.                                      
       01  W-BUFFER    PIC X(1920).
       01  W-RESP      PIC S9(8) COMP.                               
       01  RESPONSE    PIC S9(8) COMP-4 VALUE 0.                       
       01  REASON-CODE PIC S9(8) COMP-4 VALUE 0.                     
       01  ABCODE       PIC X(4) VALUE SPACES.
       01  JUST-NOW    PIC X VALUE " ".
       01  FILEOP-FAILED PIC X VALUE " ".
       01  ACCOUNT-FOUND PIC X VALUE " ".
       01  W-DEBIT     PIC S9(13)V999.
       01  W-CREDIT    PIC S9(13)V999.
       01  W-UNDERC    PIC X(4).
       01  W-CURLIN    PIC 99.
       01  W-CURCOL    PIC 99.
       01  W-CURSUB    PIC 99.
       01  W-CURSUB1   PIC 99.
       01  W-NUM       PIC 9(13)V99.
       01  W-NUMX      PIC X(16).
       01  W-NUMXX     PIC X(16).
       01  W-EXTRA     PIC X(128).
       01  EOFLIST     PIC X.
       01  ENQ-TEXT    PIC X(15).
       01  W-SERIAL    PIC 9(9).
       01  SAVE-FLAG   PIC X VALUE SPACE.
       01  W-CTR       PIC 99.                                          
       01  LEAP-YEAR   PIC X.                                          
       01  ERR-DATE    PIC X.                                         
       01  W-WASTE     PIC X.
       01  W-FLAG      PIC X.
       01  W-LEN       PIC 99.
       01  SUB         PIC 99.
       01  MUB         PIC 99.
       01  VALIDATION-ERR PIC X VALUE SPACE.                           
       01  RAWTIME     PIC S9(16) COMP.                               
       01  W-DATE      PIC X(10).                                 
       01  W-DATE1.                                           
           05  W-YY1   PIC 9999.                           
           05  W-MM1   PIC 99.                                        
           05  W-DD1   PIC 99.                                     
       01  W-DATE2.                                               
           05  W-YY2   PIC 9999.                                     
           05  W-MM2   PIC 99.                                        
           05  W-DD2   PIC 99.                                         
       01  W-DATE-NUM  PIC S9(18) VALUE 0.                            
       01  W-MESG      PIC X(50) VALUE SPACES.                       
       01  WS-CF-AREA.                                              
           05  WS-TSQ-NAME.                                       
               10  WS-TSQ-TRNID   PIC X(04).                         
               10  WS-TSQ-TRMID   PIC X(04).                           
           05  WS-TSQ-LENGTH      PIC S9(4) COMP.                    
           05  WS-TSQ-ITEM        PIC S9(4) COMP.                     
           05  WS-TSQ-COUNT       PIC 99.                            
           05  WS-TSQ-RECORD      PIC X(15328).                    
       01  CO-REC.
           05 CO-CODE             PIC X(2).
           05 CO-NAME             PIC X(50).
           05 CO-ADD1             PIC X(40).
           05 CO-ADD2             PIC X(40).
           05 CO-ADD3             PIC X(40).
           05 CO-ADD4             PIC X(40).
           05 CO-PIN              PIC X(6).
           05 CO-IT-NO            PIC X(40).
           05 CO-ST-NO            PIC X(40).
           05 CO-SST-NO           PIC X(40).
           05 CO-OTH-TAX1         PIC X(40).
           05 CO-OTH-TAX2         PIC X(40).
           05 CO-OTH-TAX3         PIC X(40).
           05 CO-FIN-YEAR-FROM    PIC X(10).
           05 CO-BOOKS-FROM       PIC X(10).
           05 FILLER              PIC X(34).
       01  IGR-REC.
           05 IGR-RIDFLD.
              10 IGR-COCODE           PIC XX.
              10 IGR-CODE             PIC X(4).
           05 IGR-NAME             PIC X(40).
           05 IGR-UNDERC           PIC X(4).
           05 IGR-UNDERN           PIC X(40).
           05 IGR-QTY              PIC X.
           05 IGR-BIN              PIC X(4).
           05 IGR-DEBITS           PIC S9(8)V999 COMP-3.
           05 IGR-CREDITS          PIC S9(8)V999 COMP-3.
           05 FILLER               PIC X(21).
       01  GRP-REC.
           05 GRP-RIDFLD.
              10 GRP-COCODE           PIC XX.
              10 GRP-CODE             PIC X(4).
           05 GRP-NAME             PIC X(40).
           05 GRP-UNDERC           PIC X(4).
           05 GRP-UNDERN           PIC X(40).
           05 GRP-NATURE           PIC X.
           05 GRP-AFF-GP           PIC X.
           05 GRP-SUB-LED          PIC X.
           05 GRP-BAL              PIC X.
           05 GRP-OPBAL            PIC S9(13)V99 COMP-3.
           05 GRP-DEBIT            PIC 9(13)V99 COMP-3.
           05 GRP-CREDIT           PIC 9(13)V99 COMP-3.
           05 GRP-CLBAL            PIC S9(13)V99 COMP-3.
           05 FILLER               PIC X(34).
       01  LED-REC.
           05 LED-RIDFLD.
              10 LED-COCODE        PIC X(2).
              10 LED-CODE          PIC X(8).
           05 LED-NAME             PIC X(50).
           05 LED-UNDERC           PIC X(4).
           05 LED-UNDERN           PIC X(40).
           05 LED-INV-YN           PIC X.
           05 LED-OPBAL            PIC S9(13)V99 COMP-3.
           05 LED-DEBIT            PIC 9(13)V99 COMP-3.
           05 LED-CREDIT           PIC 9(13)V99 COMP-3.
           05 LED-CLBAL            PIC S9(13)V99 COMP-3.
           05 LED-MAIL-NAME        PIC X(40).
           05 LED-ADD1             PIC X(40).
           05 LED-ADD2             PIC X(40).
           05 LED-ADD3             PIC X(40).
           05 LED-PIN              PIC 9(6).
           05 LED-TEL              PIC X(15).
           05 LED-FAX              PIC X(15).
           05 LED-MOBILE           PIC X(11).
           05 LED-EMAIL            PIC X(50).
           05 LED-IT-NO            PIC X(40).
           05 LED-ST-NO            PIC X(40).
           05 FILLER               PIC X(38).
       01  ITM-REC.
           05 ITM-RIDFLD.
              10 ITM-COCODE           PIC XX.
              10 ITM-CODE             PIC X(8).
           05 ITM-NAME             PIC X(40).
           05 ITM-UNDERC           PIC X(4).
           05 ITM-UNITS            PIC X(5).
           05 ITM-OPBAL            PIC S9(8)V999 COMP-3.
           05 ITM-DEBIT            PIC S9(8)V999 COMP-3.
           05 ITM-CREDIT           PIC S9(8)V999 COMP-3.
           05 ITM-CLBAL            PIC S9(8)V999 COMP-3.
           05 ITM-RATE             PIC S9(12)V99 COMP-3.
           05 ITM-BIN              PIC X(8).
           05 ITM-REORD            PIC 9(8)V999 COMP-3.
           05 ITM-MIN              PIC 9(8)V999 COMP-3.
           05 ITM-MAX              PIC 9(8)V999 COMP-3.
           05 ITM-SELMETH          PIC X(1).
           05 FILLER               PIC X(10).
       01  W-LED-CODE              PIC X(8).
       01  W-ITM-CODE              PIC X(8).

       01  TFILLER  PIC X(16) VALUE "TRAN RECORD STRT".
       01  XAMT-FOR-AGE            PIC X(44).
       01  AMT-FOR-AGE
                                   REDEFINES XAMT-FOR-AGE
                                   PIC 9(13)V99 COMP-3.
       01  SAV-TRN-REC             PIC X(852).
       01  TRN-REC1.                                                     
           05 TRN-RIDFLD1.
              10 TRN-COCODE1        PIC XX.
              10 TRN-TYPE1          PIC X(5).                            
              10 TRN-ADATE1         PIC X(8).
              10 TRN-SERIAL1        PIC 9(9).
           05 TRN-DSUM1             PIC 9(13)V99 COMP-3.
           05 TRN-CSUM1             PIC 9(13)V99 COMP-3.
           05 TRN-FILLER1           PIC X(44).
           05 TRN-COUNT1            PIC 99.
      *    05 TRN-DETAILS OCCURS 2 TO 15 DEPENDING ON TRN-COUNT.
           05 TRN-DETAILS1 OCCURS 15.
              10 TRN-ACCOUNT1       PIC X(8).
              10 TRN-SHRTNR1        PIC X(30).
              10 TRN-DEBIT1         PIC 9(13)V99 COMP-3.
              10 TRN-CREDIT1        PIC 9(13)V99 COMP-3.
       01  ITRN-REC1.
           05 ITRN-RIDFLD1.
              10 ITRN-COCODE1        PIC XX.
              10 ITRN-TYPE1          PIC X(5).
              10 ITRN-ADATE1         PIC X(8).
              10 ITRN-SERIAL1        PIC 9(9).
           05 ITRN-COUNT1            PIC 99.
      *    05 ITRN-DETAILS OCCURS 2 TO 15 TIMES DEPENDING ON ITRN-COUNT.
           05 ITRN-DETAILS1 OCCURS 15.
              10 ITRN-INDV1 OCCURS 15.
                 15  ITRN-ITEM1      PIC X(8).
                 15  ITRN-DESC1      PIC X(40).
                 15  ITRN-QTY1       PIC 9(8)V999 COMP-3.
                 15  ITRN-SALERT1    PIC 9(8)V999 COMP-3.
                 15  ITRN-AMOUNT1    PIC 9(13)V99 COMP-3.
       01 TEMP-SERIAL            PIC 9(9).
       01 W-TEXT                 PIC X(60).
       LINKAGE SECTION.                                                 
       01  DFHCOMMAREA.
           05  DFHCOMMAND      PIC X(4).
           05  DFHLOGON.
               10  WSHOP       PIC XX.
               10  WUSER       pic x(8).
           05  TRN-REC.
               10 TRN-RIDFLD.
                  15 TRN-COCODE        PIC XX.
                  15 TRN-TYPE          PIC X(5).
                  15 TRN-ADATE         PIC X(8).
                  15 TRN-SERIAL        PIC 9(9).
               10 TRN-DSUM             PIC 9(13)V99 COMP-3.
               10 TRN-CSUM             PIC 9(13)V99 COMP-3.
               10 TRN-FILLER           PIC X(44).
               10 TRN-COUNT            PIC 99.
               10 TRN-DETAILS OCCURS 15.
                  15 TRN-ACCOUNT       PIC X(8).
                  15 TRN-SHRTNR        PIC X(30).
                  15 TRN-DEBIT         PIC S9(13)V99 COMP-3.
                  15 TRN-CREDIT        PIC S9(13)V99 COMP-3.
           05  ITRN-REC.
               10 ITRN-RIDFLD.
                  15 ITRN-COCODE        PIC XX.
                  15 ITRN-TYPE          PIC X(5).
                  15 ITRN-ADATE         PIC X(8).
                  15 ITRN-SERIAL        PIC 9(9).
               10 ITRN-COUNT            PIC 99.
               10 ITRN-DETAILS OCCURS 15.
                  15 ITRN-INDV OCCURS 15.
                     20  ITRN-ITEM      PIC X(8).
                     20  ITRN-DESC      PIC X(40).
                     20  ITRN-QTY       PIC S9(8)V999 COMP-3.
                     20  ITRN-SALERT    PIC S9(8)V999 COMP-3.
                     20  ITRN-AMOUNT    PIC S9(13)V99 COMP-3.
           05  D-RESULT  OCCURS 50.
               10  D-LED-CODE               PIC X(8).
               10  D-LED-NAME               PIC X(50).
               10  D-ITM-CODE               PIC X(8).
               10  D-ITM-NAME               PIC X(50).
               10  D-ITM-CLBAL            PIC S9(8)V999 COMP-3.
               10  D-ITM-RATE             PIC S9(12)V99 COMP-3.
           05  D-RESP                 PIC S9(4) COMP.

       PROCEDURE DIVISION.                                              
       MAIN-PROGRAM SECTION.                                           
           COPY "ERROR-HANDLING".
       000-MAIN-PARA.                                                 
           IF DFHCOMMAND = 'GLFA'
              PERFORM GLFA.
           IF DFHCOMMAND = 'GLIA'
              PERFORM GLIA.
           IF DFHCOMMAND = 'GFTR'
              PERFORM GFTR.
           IF DFHCOMMAND = 'GNFT'
              PERFORM GNFT.
           IF DFHCOMMAND = 'GPFT'
              PERFORM GPFT.
           IF DFHCOMMAND = 'ATRN'
              PERFORM ATRN.
           IF DFHCOMMAND = 'GLFG'
              PERFORM GLFG.
           IF DFHCOMMAND = 'GLIG'
              PERFORM GLIG.
           EXEC CICS RETURN END-EXEC.
       ATRN SECTION.
           MOVE TRN-REC TO SAV-TRN-REC.
           MOVE WSHOP TO TRN-COCODE.
           MOVE TRN-RIDFLD TO ENQ-TEXT
           EXEC CICS ENQ RESOURCE(ENQ-TEXT) LENGTH(15) END-EXEC
           MOVE 0 TO W-RESP
           MOVE 0 TO W-SERIAL
           EXEC CICS IGNORE CONDITION NOTFND END-EXEC.
           PERFORM UNTIL EIBRESP NOT = 0
              ADD 1 TO W-SERIAL
              MOVE W-SERIAL TO TRN-SERIAL
              EXEC CICS READ FILE("TRNFILE")
                        RIDFLD(TRN-RIDFLD)
                        INTO(TRN-REC)
                        LENGTH(LENGTH OF TRN-REC)
                        KEYLENGTH(LENGTH OF TRN-RIDFLD)
      *                 RESP(W-RESP)
              END-EXEC
           END-PERFORM.
           MOVE SAV-TRN-REC TO TRN-REC.
           MOVE WSHOP TO TRN-COCODE.
      *    ADD 1 TO W-SERIAL.
           MOVE W-SERIAL TO TRN-SERIAL ITRN-SERIAL.
           EXEC CICS WRITE FILE("TRNFILE")
                           FROM(TRN-REC)
                           RIDFLD(TRN-RIDFLD)
                           LENGTH(LENGTH OF TRN-REC)
                           KEYLENGTH(LENGTH OF TRN-RIDFLD)
      *                    RESP(W-RESP)
           END-EXEC.
           IF W-RESP = DFHRESP(NORMAL)
              MOVE 0 TO D-RESP
              EXEC CICS WRITE FILE("ITRNFILE")
                              FROM(ITRN-REC)
                              RIDFLD(ITRN-RIDFLD)
                              LENGTH(LENGTH OF ITRN-REC)
                              KEYLENGTH(LENGTH OF ITRN-RIDFLD)
      *                       RESP(W-RESP)
              END-EXEC
              IF W-RESP NOT = DFHRESP(NORMAL)
                 MOVE -1 TO D-RESP
                 EXEC CICS SYNCPOINT ROLLBACK END-EXEC
              ELSE
                 MOVE 'N' TO FILEOP-FAILED
                 PERFORM 2000-UPDATE-MASTERS
                 IF FILEOP-FAILED = 'Y'
                    EXEC CICS SYNCPOINT ROLLBACK END-EXEC
                 ELSE
                    EXEC CICS SYNCPOINT END-EXEC
                 END-IF
              END-IF

           ELSE
              MOVE -1 TO D-RESP
           END-IF.
           EXEC CICS DEQ RESOURCE(ENQ-TEXT) LENGTH(15) END-EXEC.
       GLFG SECTION.
           MOVE WSHOP TO GRP-COCODE.
           MOVE D-LED-CODE(1) TO GRP-CODE.
           EXEC CICS STARTBR
                     FILE('GRPFILE')
                     RIDFLD(GRP-RIDFLD)
                     KEYLENGTH(LENGTH OF GRP-RIDFLD)
                     RESP(W-RESP)
                     GTEQ
           END-EXEC.
           IF W-RESP NOT = DFHRESP(NORMAL)
              MOVE SPACES TO GRP-CODE
              EXEC CICS STARTBR
                     FILE('GRPFILE')
                     RIDFLD(GRP-RIDFLD)
                     KEYLENGTH(LENGTH OF GRP-RIDFLD)
                     RESP(W-RESP)
                     GTEQ
              END-EXEC
              IF W-RESP = DFHRESP(NORMAL)
                 MOVE 2 TO D-RESP
              ELSE
                 MOVE 10 TO D-RESP
              END-IF
           ELSE
              MOVE 0 TO D-RESP
           END-IF.
           IF D-RESP = 0 OR 2
              MOVE 'N' TO EOFLIST
              PERFORM VARYING SUB FROM 1 BY 1 UNTIL SUB > 50
                               OR EOFLIST = 'Y'
                  EXEC CICS READNEXT
                            FILE('GRPFILE')
                            RIDFLD(GRP-RIDFLD)
                            LENGTH(LENGTH OF GRP-REC)
                            INTO(GRP-REC)
                            RESP(W-RESP)
                  END-EXEC
                  IF  W-RESP = DFHRESP(NORMAL)
                      MOVE GRP-CODE TO D-LED-CODE(SUB)
                      MOVE GRP-NAME TO D-LED-NAME(SUB)
                  ELSE
                      MOVE 'Y' TO EOFLIST
                  END-IF
              END-PERFORM
           END-IF.
           EXEC CICS ENDBR
                     FILE('GRPFILE')
                     RESP(W-RESP)
           END-EXEC.
       GLIG SECTION.
           MOVE WSHOP TO IGR-COCODE.
           MOVE D-ITM-CODE(1) TO IGR-CODE.
           EXEC CICS STARTBR
                     FILE('IGRFILE')
                     RIDFLD(IGR-RIDFLD)
                     KEYLENGTH(LENGTH OF IGR-RIDFLD)
      *              RESP(W-RESP)
                     GTEQ
           END-EXEC.
           IF W-RESP = DFHRESP(NORMAL)
              EXEC CICS IGNORE CONDITION ENDFILE END-EXEC
              MOVE 'N' TO EOFLIST
              PERFORM VARYING SUB FROM 1 BY 1 UNTIL SUB > 50
                               OR EOFLIST = 'Y'
                  EXEC CICS READNEXT
                            FILE('IGRFILE')
                            RIDFLD(IGR-RIDFLD)
                            LENGTH(LENGTH OF IGR-REC)
                            INTO(IGR-REC)
      *                     RESP(W-RESP)
                  END-EXEC
      *           IF  W-RESP = DFHRESP(NORMAL)
                  IF  EIBRESP = DFHRESP(NORMAL)
                      MOVE IGR-CODE TO D-ITM-CODE(SUB)
                      MOVE IGR-NAME TO D-ITM-NAME(SUB)
                  ELSE
                      MOVE 'Y' TO EOFLIST
                  END-IF
              END-PERFORM
           END-IF.
           EXEC CICS ENDBR
                     FILE('IGRFILE')
      *              RESP(W-RESP)
           END-EXEC.
       GPFT SECTION.
           MOVE WSHOP TO TRN-COCODE.
           EXEC CICS STARTBR
                     FILE('TRNFILE')
                     RIDFLD(TRN-RIDFLD)
                     KEYLENGTH(LENGTH OF TRN-RIDFLD)
                     RESP(W-RESP)
                     EQUAL
           END-EXEC.
           IF W-RESP NOT = DFHRESP(NORMAL)
              MOVE 10 TO D-RESP
           ELSE
              EXEC CICS READPREV
                        FILE('TRNFILE')
                        RIDFLD(TRN-RIDFLD)
                        LENGTH(LENGTH OF TRN-REC)
                        INTO(TRN-REC)
                        RESP(W-RESP)
              END-EXEC
              EXEC CICS READPREV
                        FILE('TRNFILE')
                        RIDFLD(TRN-RIDFLD)
                        LENGTH(LENGTH OF TRN-REC)
                        INTO(TRN-REC)
                        RESP(W-RESP)
              END-EXEC
              IF W-RESP NOT = DFHRESP(NORMAL)
                 MOVE 10 TO D-RESP
              END-IF
           END-IF.
           EXEC CICS ENDBR
                     FILE('TRNFILE')
                     RESP(W-RESP)
           END-EXEC.
       GNFT SECTION.
           MOVE WSHOP TO TRN-COCODE.
           EXEC CICS STARTBR
                     FILE('TRNFILE')
                     RIDFLD(TRN-RIDFLD)
                     KEYLENGTH(LENGTH OF TRN-RIDFLD)
                     RESP(W-RESP)
                     GTEQ
           END-EXEC.
           IF W-RESP NOT = DFHRESP(NORMAL)
              MOVE 10 TO D-RESP
           ELSE
              EXEC CICS READNEXT
                        FILE('TRNFILE')
                        RIDFLD(TRN-RIDFLD)
                        LENGTH(LENGTH OF TRN-REC)
                        INTO(TRN-REC)
                        RESP(W-RESP)
              END-EXEC
              IF W-RESP NOT = DFHRESP(NORMAL)
                 MOVE 10 TO D-RESP
              END-IF
           END-IF.
           EXEC CICS ENDBR
                     FILE('TRNFILE')
                     RESP(W-RESP)
           END-EXEC.
       GFTR SECTION.
           MOVE WSHOP TO TRN-COCODE.
           EXEC CICS STARTBR
                     FILE('TRNFILE')
                     RIDFLD(TRN-RIDFLD)
                     KEYLENGTH(LENGTH OF TRN-RIDFLD)
                     RESP(W-RESP)
                     EQUAL
           END-EXEC.
           IF W-RESP NOT = DFHRESP(NORMAL)
              MOVE 10 TO D-RESP
           ELSE
              EXEC CICS READNEXT
                        FILE('TRNFILE')
                        RIDFLD(TRN-RIDFLD)
                        LENGTH(LENGTH OF TRN-REC)
                        INTO(TRN-REC)
                        RESP(W-RESP)
              END-EXEC
              IF W-RESP NOT = DFHRESP(NORMAL)
                 MOVE 10 TO D-RESP
              END-IF
           END-IF.
           EXEC CICS ENDBR
                     FILE('TRNFILE')
                     RESP(W-RESP)
           END-EXEC.
       GLIA SECTION.
           MOVE WSHOP TO ITM-COCODE.
           MOVE D-ITM-CODE(1) TO ITM-CODE.
           IF ITM-CODE NOT = "  "
              IF ITM-CODE(5:4) = "  "
                 MOVE ITM-CODE TO W-ITM-CODE
              ELSE
                 MOVE SPACES TO W-ITM-CODE
           END-IF.
           EXEC CICS STARTBR
                     FILE('ITMFILE')
                     RIDFLD(ITM-RIDFLD)
                     KEYLENGTH(LENGTH OF ITM-RIDFLD)
      *              RESP(W-RESP)
                     GTEQ
           END-EXEC.
           IF W-RESP NOT = DFHRESP(NORMAL)
              MOVE 10 TO D-RESP
           ELSE
              MOVE 0 TO D-RESP
           END-IF.
           IF D-RESP = 0
              MOVE 'N' TO EOFLIST
              EXEC CICS IGNORE CONDITION ENDFILE END-EXEC
              PERFORM VARYING SUB FROM 1 BY 1 UNTIL SUB > 50
                               OR EOFLIST = 'Y'
                  EXEC CICS READNEXT
                            FILE('ITMFILE')
                            RIDFLD(ITM-RIDFLD)
                            LENGTH(LENGTH OF ITM-REC)
                            INTO(ITM-REC)
      *                     RESP(W-RESP)
                  END-EXEC
      *           IF  W-RESP = DFHRESP(NORMAL)
                  IF  EIBRESP = DFHRESP(NORMAL)
                      MOVE ITM-CODE TO D-ITM-CODE(SUB)
                      MOVE ITM-NAME TO D-ITM-NAME(SUB)
                      MOVE ITM-CLBAL TO D-ITM-CLBAL(SUB)
                      MOVE ITM-RATE  TO D-ITM-RATE(SUB)
                  ELSE
                      MOVE 'Y' TO EOFLIST
                  END-IF
                  IF W-ITM-CODE NOT = "  "
                     IF W-ITM-CODE NOT = ITM-CODE(1:4)
                        MOVE 'Y' TO EOFLIST
                     END-IF
                  END-IF
              END-PERFORM
           END-IF.
           EXEC CICS ENDBR
                     FILE('ITMFILE')
      *              RESP(W-RESP)
           END-EXEC.
       GLFA SECTION.
           MOVE WSHOP TO LED-COCODE.
           MOVE D-LED-CODE(1) TO LED-CODE.
           IF LED-CODE NOT = "  "
              IF LED-CODE(5:4) = "  "
                 MOVE LED-CODE TO W-LED-CODE
              ELSE
                 MOVE SPACES TO W-LED-CODE
           END-IF.
           EXEC CICS STARTBR
                     FILE('LEDFILE')
                     RIDFLD(LED-RIDFLD)
                     KEYLENGTH(LENGTH OF LED-RIDFLD)
                     RESP(W-RESP)
                     GTEQ
           END-EXEC.
           IF W-RESP NOT = DFHRESP(NORMAL)
              MOVE 10 TO D-RESP
           ELSE
              MOVE 0 TO D-RESP
           END-IF.
           IF D-RESP = 0 OR 2
              MOVE 'N' TO EOFLIST
              PERFORM VARYING SUB FROM 1 BY 1 UNTIL SUB > 50
                               OR EOFLIST = 'Y'
                  EXEC CICS READNEXT
                            FILE('LEDFILE')
                            RIDFLD(LED-RIDFLD)
                            LENGTH(LENGTH OF LED-REC)
                            INTO(LED-REC)
                            RESP(W-RESP)
                  END-EXEC
                  IF  W-RESP = DFHRESP(NORMAL)
                      MOVE LED-CODE TO D-LED-CODE(SUB)
                      MOVE LED-NAME TO D-LED-NAME(SUB)
                  ELSE
                      MOVE 'Y' TO EOFLIST
                  END-IF
                  IF W-LED-CODE NOT = "  "
                     IF W-LED-CODE NOT = LED-CODE(1:4)
                        MOVE 'Y' TO EOFLIST
                     END-IF
                  END-IF
              END-PERFORM
           END-IF.
           EXEC CICS ENDBR
                     FILE('LEDFILE')
                     RESP(W-RESP)
           END-EXEC.
******************************************************************
       MISCELLANEOUS SECTION.
       2000-UPDATE-MASTERS.
           MOVE WSHOP TO LED-COCODE.
           PERFORM VARYING SUB FROM 1 BY 1 UNTIL SUB > 15
              IF TRN-ACCOUNT(SUB) NOT = '  '
                 MOVE TRN-ACCOUNT(SUB) TO LED-CODE
                 EXEC CICS READ FILE('LEDFILE')
                           INTO(LED-REC)
                           RIDFLD(LED-RIDFLD)
                           LENGTH(LENGTH OF LED-REC)
                           KEYLENGTH(LENGTH OF LED-RIDFLD)
                           EQUAL
      *                    RESP(W-RESP)
                           UPDATE
                 END-EXEC
                 IF W-RESP NOT = DFHRESP(NORMAL)
                    MOVE 'Y' TO FILEOP-FAILED
                 ELSE
                    MOVE TRN-DEBIT(SUB) TO W-DEBIT
                    MOVE TRN-CREDIT(SUB) TO W-CREDIT
                    MOVE LED-UNDERC TO W-UNDERC
                    ADD TRN-DEBIT(SUB) TO LED-DEBIT
                    ADD TRN-CREDIT(SUB) TO LED-CREDIT
                    COMPUTE LED-CLBAL = LED-OPBAL +
                                        LED-DEBIT -
                                        LED-CREDIT
                    EXEC CICS REWRITE FILE('LEDFILE')
                                      FROM(LED-REC)
                                      LENGTH(LENGTH OF LED-REC)
      *                               RESP(W-RESP)
                    END-EXEC
                    IF W-RESP NOT = DFHRESP(NORMAL)
                       MOVE 'Y' TO FILEOP-FAILED
                    ELSE
                       EXEC CICS UNLOCK FILE('LEDFILE')
                       END-EXEC
                       IF LED-UNDERC NOT = '  '
                          PERFORM 2050-UPDATE-GROUPS
                       END-IF
                       PERFORM 2100-UPDATE-MASTERS
                    END-IF
                 END-IF
              END-IF
           END-PERFORM.


       2100-UPDATE-MASTERS.
           MOVE WSHOP TO ITM-COCODE.
           PERFORM VARYING MUB FROM 1 BY 1 UNTIL MUB > 15
              IF ITRN-ITEM(SUB, MUB) NOT = '  '
                 MOVE ITRN-ITEM(SUB, MUB) TO ITM-CODE
                 EXEC CICS READ FILE('ITMFILE')
                           INTO(ITM-REC)
                           RIDFLD(ITM-RIDFLD)
                           LENGTH(LENGTH OF ITM-REC)
                           KEYLENGTH(LENGTH OF ITM-RIDFLD)
                           EQUAL
      *                    RESP(W-RESP)
                           UPDATE
                 END-EXEC
                 IF W-RESP NOT = DFHRESP(NORMAL)
                    MOVE 'Y' TO FILEOP-FAILED
                 ELSE
                    MOVE 0 TO W-DEBIT W-CREDIT
                    MOVE ITM-UNDERC TO W-UNDERC
      *             IF TRN-DEBIT(SUB) > 0
      *                ADD ITRN-QTY(SUB, MUB) TO ITM-DEBIT W-DEBIT
      *             ELSE
                       ADD ITRN-QTY(SUB, MUB) TO ITM-CREDIT W-CREDIT
      *             END-IF
                    COMPUTE ITM-CLBAL = ITM-OPBAL +
                                        ITM-DEBIT -
                                        ITM-CREDIT
                    EXEC CICS REWRITE FILE('ITMFILE')
                                      FROM(ITM-REC)
                                      LENGTH(LENGTH OF ITM-REC)
      *                               RESP(W-RESP)
                    END-EXEC
                    IF W-RESP NOT = DFHRESP(NORMAL)
                       MOVE 'Y' TO FILEOP-FAILED
                    ELSE
                       EXEC CICS UNLOCK FILE('ITMFILE')
                       END-EXEC
                       IF ITM-UNDERC NOT = ' '
                          PERFORM 3050-UPDATE-IGROUPS
                       END-IF
                    END-IF
                 END-IF
              END-IF
           END-PERFORM.
       3000-UPDATE-MASTERS.
           MOVE WSHOP TO LED-COCODE.
           PERFORM VARYING SUB FROM 1 BY 1 UNTIL SUB > 15
              IF TRN-ACCOUNT(SUB) NOT = '  '
                 MOVE TRN-ACCOUNT(SUB) TO LED-CODE
                 EXEC CICS READ FILE('LEDFILE')
                           INTO(LED-REC)
                           RIDFLD(LED-RIDFLD)
                           LENGTH(LENGTH OF LED-REC)
                           KEYLENGTH(LENGTH OF LED-RIDFLD)
                           EQUAL
                           RESP(W-RESP)
                           UPDATE
                 END-EXEC
                 IF W-RESP NOT = DFHRESP(NORMAL)
                    MOVE 'Y' TO FILEOP-FAILED
                 ELSE
                    COMPUTE W-DEBIT = TRN-DEBIT(SUB) - TRN-DEBIT1(SUB)
                    COMPUTE W-CREDIT = TRN-CREDIT(SUB) -
                                       TRN-CREDIT1(SUB)
                    MOVE LED-UNDERC TO W-UNDERC
                    ADD TRN-DEBIT(SUB) TO LED-DEBIT
                    ADD TRN-CREDIT(SUB) TO LED-CREDIT
                    SUBTRACT TRN-DEBIT1(SUB) FROM LED-DEBIT
                    SUBTRACT TRN-CREDIT1(SUB) FROM LED-CREDIT
                    COMPUTE LED-CLBAL = LED-OPBAL +
                                        LED-DEBIT -
                                        LED-CREDIT
                    EXEC CICS REWRITE FILE('LEDFILE')
                                      FROM(LED-REC)
                                      LENGTH(LENGTH OF LED-REC)
                                      RESP(W-RESP)
                    END-EXEC
                    IF W-RESP NOT = DFHRESP(NORMAL)
                       MOVE 'Y' TO FILEOP-FAILED
                    ELSE
                       EXEC CICS UNLOCK FILE('LEDFILE')
                       END-EXEC
                       IF LED-UNDERC NOT = ' '
                          PERFORM 2050-UPDATE-GROUPS
                       END-IF
                       PERFORM 3100-UPDATE-MASTERS
                    END-IF
                 END-IF
              END-IF
           END-PERFORM.
       3100-UPDATE-MASTERS.
           MOVE WSHOP TO ITM-COCODE.
           PERFORM VARYING MUB FROM 1 BY 1 UNTIL MUB > 15
              IF ITRN-ITEM(SUB, MUB) NOT = '  '
                 MOVE ITRN-ITEM(SUB, MUB) TO ITM-CODE
                 EXEC CICS READ FILE('ITMFILE')
                           INTO(ITM-REC)
                           RIDFLD(ITM-RIDFLD)
                           EQUAL
                           LENGTH(LENGTH OF ITM-REC)
                           KEYLENGTH(LENGTH OF ITM-RIDFLD)
                           RESP(W-RESP)
                           UPDATE
                 END-EXEC
                 IF W-RESP NOT = DFHRESP(NORMAL)
                    MOVE 'Y' TO FILEOP-FAILED
                 ELSE
                    MOVE 0 TO W-DEBIT W-CREDIT
                    MOVE ITM-UNDERC TO W-UNDERC
                    IF TRN-DEBIT(SUB) > 0
                       ADD ITRN-QTY(SUB, MUB) TO ITM-DEBIT W-DEBIT
                    ELSE
                       ADD ITRN-QTY(SUB, MUB) TO ITM-CREDIT W-CREDIT
                    END-IF
                    IF TRN-DEBIT1(SUB) > 0
                       SUBTRACT ITRN-QTY1(SUB, MUB) FROM ITM-DEBIT
                                                         W-DEBIT
                    ELSE
                       SUBTRACT ITRN-QTY1(SUB, MUB) FROM ITM-CREDIT
                                                         W-CREDIT
                    END-IF
                    COMPUTE ITM-CLBAL = ITM-OPBAL +
                                        ITM-DEBIT -
                                        ITM-CREDIT
                    EXEC CICS REWRITE FILE('ITMFILE')
                                      FROM(ITM-REC)
                                      LENGTH(LENGTH OF ITM-REC)
                                      RESP(W-RESP)
                    END-EXEC
                    IF W-RESP NOT = DFHRESP(NORMAL)
                       MOVE 'Y' TO FILEOP-FAILED
                    ELSE
                       EXEC CICS UNLOCK FILE('ITMFILE')
                       END-EXEC
                       IF ITM-UNDERC NOT = '  '
                          PERFORM 3050-UPDATE-IGROUPS
                       END-IF
                    END-IF
                 END-IF
              END-IF
           END-PERFORM.
       4000-UPDATE-MASTERS.
           MOVE WSHOP TO LED-COCODE.
           PERFORM VARYING SUB FROM 1 BY 1 UNTIL SUB > 15
              IF TRN-ACCOUNT(SUB) NOT = '  '
                 MOVE TRN-ACCOUNT(SUB) TO LED-CODE
                 EXEC CICS READ FILE('LEDFILE')
                           INTO(LED-REC)
                           RIDFLD(LED-RIDFLD)
                           LENGTH(LENGTH OF LED-REC)
                           KEYLENGTH(LENGTH OF LED-RIDFLD)
                           EQUAL
                           RESP(W-RESP)
                           UPDATE
                 END-EXEC
                 IF W-RESP NOT = DFHRESP(NORMAL)
                    MOVE 'Y' TO FILEOP-FAILED
                 ELSE
                    COMPUTE W-DEBIT = LED-DEBIT * -1
                    COMPUTE W-CREDIT = LED-CREDIT * -1
                    MOVE LED-UNDERC TO W-UNDERC
                    SUBTRACT TRN-DEBIT(SUB) FROM LED-DEBIT
                    SUBTRACT TRN-CREDIT(SUB) FROM LED-CREDIT
                    COMPUTE LED-CLBAL = LED-OPBAL +
                                        LED-DEBIT -
                                        LED-CREDIT
                    EXEC CICS REWRITE FILE('LEDFILE')
                                      FROM(LED-REC)
                                      LENGTH(LENGTH OF LED-REC)
                                      RESP(W-RESP)
                    END-EXEC
                    IF W-RESP NOT = DFHRESP(NORMAL)
                       MOVE 'Y' TO FILEOP-FAILED
                    ELSE
                       EXEC CICS UNLOCK FILE('LEDFILE')
                       END-EXEC
                       IF LED-UNDERC NOT = ' '
                          PERFORM 2050-UPDATE-GROUPS
                       END-IF
                       PERFORM 4100-UPDATE-MASTERS
                    END-IF
                 END-IF
              END-IF
           END-PERFORM.
       4100-UPDATE-MASTERS.
           MOVE WSHOP TO ITM-COCODE.
           PERFORM VARYING MUB FROM 1 BY 1 UNTIL MUB > 15
              IF ITRN-ITEM(SUB, MUB) NOT = '  '
                 MOVE ITRN-ITEM(SUB, MUB) TO ITM-CODE
                 EXEC CICS READ FILE('ITMFILE')
                           INTO(ITM-REC)
                           RIDFLD(ITM-RIDFLD)
                           LENGTH(LENGTH OF ITM-REC)
                           KEYLENGTH(LENGTH OF ITM-RIDFLD)
                           EQUAL
                           RESP(W-RESP)
                           UPDATE
                 END-EXEC
                 IF W-RESP NOT = DFHRESP(NORMAL)
                    MOVE 'Y' TO FILEOP-FAILED
                 ELSE
                    MOVE 0 TO W-DEBIT W-CREDIT
                    MOVE ITM-UNDERC TO W-UNDERC
                    IF TRN-DEBIT(SUB) > 0
                       SUBTRACT ITRN-QTY(SUB, MUB) FROM ITM-DEBIT
                                                        W-DEBIT
                    ELSE
                       SUBTRACT ITRN-QTY(SUB, MUB) FROM ITM-CREDIT
                                                        W-CREDIT
                    END-IF
                    COMPUTE ITM-CLBAL = ITM-OPBAL +
                                        ITM-DEBIT -
                                        ITM-CREDIT
                    EXEC CICS REWRITE FILE('ITMFILE')
                                      FROM(ITM-REC)
                                      LENGTH(LENGTH OF ITM-REC)
                                      RESP(W-RESP)
                    END-EXEC
                    IF W-RESP NOT = DFHRESP(NORMAL)
                       MOVE 'Y' TO FILEOP-FAILED
                    ELSE
                       EXEC CICS UNLOCK FILE('ITMFILE')
                       END-EXEC
                       IF ITM-UNDERC NOT = '  '
                          PERFORM 3050-UPDATE-IGROUPS
                       END-IF
                    END-IF
                 END-IF
              END-IF
           END-PERFORM.
       2050-UPDATE-GROUPS.
           MOVE WSHOP TO GRP-COCODE.
           MOVE W-UNDERC TO GRP-CODE.
           EXEC CICS READ FILE('GRPFILE')
                          INTO(GRP-REC)
                          RIDFLD(GRP-RIDFLD)
                          LENGTH(LENGTH OF GRP-REC)
                          KEYLENGTH(LENGTH OF GRP-RIDFLD)
                          EQUAL
      *                   RESP(W-RESP)
                          UPDATE
           END-EXEC.
           ADD W-DEBIT TO GRP-DEBIT.
           ADD W-CREDIT TO GRP-CREDIT.
           COMPUTE GRP-CLBAL = GRP-OPBAL + GRP-DEBIT - GRP-CREDIT.
           EXEC CICS REWRITE FILE('GRPFILE')
                             FROM(GRP-REC)
                             LENGTH(LENGTH OF GRP-REC)
      *                      RESP(W-RESP)
           END-EXEC.
           EXEC CICS UNLOCK FILE('GRPFILE')
           END-EXEC.
           IF GRP-UNDERC NOT = '  '
              MOVE GRP-UNDERC TO W-UNDERC
              GO TO 2050-UPDATE-GROUPS
           END-IF.
       3050-UPDATE-IGROUPS.
           MOVE WSHOP TO IGR-COCODE.
           MOVE W-UNDERC TO IGR-CODE.
           EXEC CICS READ FILE('IGRFILE')
                          INTO(IGR-REC)
                          RIDFLD(IGR-RIDFLD)
                          LENGTH(LENGTH OF IGR-REC)
                          KEYLENGTH(LENGTH OF IGR-RIDFLD)
                          EQUAL
      *                   RESP(W-RESP)
                          UPDATE
           END-EXEC.
           ADD W-DEBIT TO IGR-DEBITS
           ADD W-CREDIT TO IGR-CREDITS.
           EXEC CICS REWRITE FILE('IGRFILE')
                             FROM(IGR-REC)
                             LENGTH(LENGTH OF IGR-REC)
      *                      RESP(W-RESP)
           END-EXEC.
           EXEC CICS UNLOCK FILE('IGRFILE')
           END-EXEC.
           IF IGR-UNDERC NOT = '  '
              MOVE IGR-UNDERC TO W-UNDERC
              GO TO 3050-UPDATE-IGROUPS
           END-IF.
