      *****************************************************************
      * DATE: 11/04/08 
      * VERSION: 1.1 
      *                                                         
      *   (C) COPYRIGHT International Business Machines Corp.   
      *   2011                                            
      *   All Rights Reserved                                   
      *   Licensed Materials - Property of IBM                  
      *   5725-C89                                              
      *                                                         
      *   US Government Users Restricted Rights -               
      *   Use, duplication or disclosure restricted by          
      *   GSA ADP Schedule Contract with IBM Corp.              
      *                                                         
      *                                                                       
      *            NOTICE TO USERS OF THE SOURCE CODE EXAMPLES                
      *                                                                       
      * INTERNATIONAL BUSINESS MACHINES CORPORATION PROVIDES THE SOURCE CODE  
      * EXAMPLES, BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS, AS IS          
      * WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,            
      * INCLUDING, BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF               
      * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE     
      * RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE CODE EXAMPLES,   
      * BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS, IS WITH YOU.  SHOULD     
      * ANY PART OF THE SOURCE CODE EXAMPLES PROVE DEFECTIVE, YOU (AND NOT    
      * IBM) ASSUME THE ENTIRE COST OF ALL NECESSARY SERVICING, REPAIR OR     
      * CORRECTION.  THIS PROGRAM MAY BE USED, EXECUTED, COPIED, MODIFIED     
      * AND DISTRIBUTED WITHOUT ROYALTY FOR THE PURPOSE OF DEVELOPING,        
      * MARKETING, OR DISTRIBUTING.                                           
      *                                                                       
      *                                                                       
      *****************************************************************                                                                   
      **************************************************************
      * ESDS FILE PROGRAM USING COBOL'S                            *
      * VSAM TRANSPARENCY FEATURE                                  *
      * THIS SAMPLE WILL BROWSE ALL THE TRANSACTION LOG            *
      * FROM THE DIGITAL LIBRARY SAMPLE                            *
      **************************************************************

       IDENTIFICATION DIVISION.
       PROGRAM-ID. DLBLOG.
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           SELECT RECORD-FILE
               ASSIGN TO 'CICS.DFHESDSF'
               ORGANIZATION IS SEQUENTIAL
               ACCESS MODE IS SEQUENTIAL
               STATUS IS RECORD-STATUS.

       DATA DIVISION.
       FILE SECTION.
       FD  RECORD-FILE 
           RECORDING MODE IS F
           DATA RECORD IS RECORD-DETAILS.
       01  RECORD-DETAILS.
           05  FORM-DATE      PIC X(10).
           05  DATE-TIME-SEP  PIC X.
           05  FORM-TIME      PIC X(8).
           05  MSG-SEP        PIC X(3).
           05  TRN-MSG        PIC X(158).

       WORKING-STORAGE SECTION.
       01  WS-WORK-AREA.
           05  EOF-INDICATOR       PIC X(4).
           05  SELECTION           PIC 9 VALUE IS ZERO.
           05  USER-DATA           PIC X(30).
           05  REC-COUNTER         PIC 9999 VALUE ZEROS.

       01  RECORD-STATUS-FIELDS.
           05  RECORD-STATUS       PIC XX VALUE '00'.
           05  RECORD-STATUS2 REDEFINES RECORD-STATUS.
               10  STATUS1         PIC X.
               10  STATUS2         PIC 9.
           05  OUTFILE-STATUS      PIC 999.

       01  RELATIVE-KEY             PIC 9(4) VALUE 1.

       PROCEDURE DIVISION.

           DISPLAY "-----------------------------------------------"
           DISPLAY "*      Sample for ESDS VT Facility            *"
           DISPLAY "*  It uses Digital Library sample files       *"
           DISPLAY "* This sample display the transaction log     *"
           DISPLAY "-----------------------------------------------"


      **************************************************************
      *           OPEN THE ESDS FILE FOR BROWSE                    *
      **************************************************************

              MOVE 'FALS' TO EOF-INDICATOR
              PERFORM OPEN-BROWSE-FILE
              PERFORM BROWSE-FILE UNTIL EOF-INDICATOR = 'TRUE'
              GO TO CLOSE-FILE.


       OPEN-BROWSE-FILE.
           OPEN INPUT RECORD-FILE.
           IF RECORD-STATUS NOT = '00'
               DISPLAY 'FAILED TO OPEN ESDS FILE, Status = '
                RECORD-STATUS
                GO TO RETURN-LABEL.
           IF STATUS1 = '9'
               DISPLAY 'FAILED TO OPEN ESDS FILE, Status = '
                RECORD-STATUS
                GO TO RETURN-LABEL.

      **************************************************************
      *           BROWSE THE ESDS FILE                             *
      **************************************************************

       BROWSE-FILE.
           READ RECORD-FILE NEXT
                AT END
                MOVE 'TRUE' TO EOF-INDICATOR.
           IF EOF-INDICATOR NOT EQUAL TO 'TRUE'
             DISPLAY RECORD-DETAILS 
             ADD 1 TO REC-COUNTER
           END-IF.

      **************************************************************
      *           CLOSE THE FILE BEFORE RETURN                     *
      **************************************************************
       CLOSE-FILE.
              IF REC-COUNTER  = 0
                 DISPLAY "NO RECORDS FOUND IN ESDS FILE CICS.DFHESDSF"
              END-IF.
              CLOSE RECORD-FILE.
              GO TO RETURN-LABEL.

       RETURN-LABEL.
             DISPLAY "-----------------------------------------------".
              GOBACK.

