      ************************************************************************
      * DATE: 11/04/29 
      * VERSION: 1.3 
      *                                                         
      *   (C) COPYRIGHT International Business Machines Corp.   
      *   2011                                            
      *   All Rights Reserved                                   
      *   Licensed Materials - Property of IBM                  
      *   5725-C89                                              
      *                                                         
      *   US Government Users Restricted Rights -               
      *   Use, duplication or disclosure restricted by          
      *   GSA ADP Schedule Contract with IBM Corp.              
      *                                                         
      *                                                                       
      *            NOTICE TO USERS OF THE SOURCE CODE EXAMPLES                
      *                                                                       
      * INTERNATIONAL BUSINESS MACHINES CORPORATION PROVIDES THE SOURCE CODE  
      * EXAMPLES, BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS, AS IS          
      * WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,            
      * INCLUDING, BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF               
      * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE     
      * RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE CODE EXAMPLES,   
      * BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS, IS WITH YOU.  SHOULD     
      * ANY PART OF THE SOURCE CODE EXAMPLES PROVE DEFECTIVE, YOU (AND NOT    
      * IBM) ASSUME THE ENTIRE COST OF ALL NECESSARY SERVICING, REPAIR OR     
      * CORRECTION.  THIS PROGRAM MAY BE USED, EXECUTED, COPIED, MODIFIED     
      * AND DISTRIBUTED WITHOUT ROYALTY FOR THE PURPOSE OF DEVELOPING,        
      * MARKETING, OR DISTRIBUTING.                                           
      *                                                                       
      *                                                                       
      **************************************************************
      * KSDS FILE PROGRAM USING COBOL'S                            *
      * VSAM TRANSPARENCY FEATURE                                  *
      * THIS SAMPLE WILL BROWSE ALL THE RECORDS                    *
      **************************************************************

       IDENTIFICATION DIVISION.
       PROGRAM-ID. EMPBRREC.
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           SELECT RECORD-FILE
               ASSIGN TO 'CICS.DFHCFIL'
               ORGANIZATION IS INDEXED
               ACCESS MODE IS SEQUENTIAL
               RECORD KEY IS ENUMB
               STATUS IS RECORD-STATUS.

       DATA DIVISION.
       FILE SECTION.
       FD  RECORD-FILE DATA RECORD IS RECORD-DETAILS.
       01  RECORD-DETAILS.
              10  ESTAT           PIC X.
              10  ENUMB           PIC X(6).
              10  ENAMEX          PIC X(20).
              10  EADDRX          PIC X(20).
              10  EPHONE          PIC X(10).
              10  EDATEX          PIC X(10).
              10  EAMOUNT         PIC X(8).
              10  ECOMMENT        PIC X(21).

       WORKING-STORAGE SECTION.
       01  WS-WORK-AREA.
           05  EOF-INDICATOR       PIC X(4).
           05  SELECTION           PIC 9 VALUE IS ZERO.
           05  USER-DATA           PIC X(30).
           05  REC-COUNTER         PIC 9999 VALUE ZEROS.
       01  SUB                     PIC 9.
       01  REMAINING-DIGITS        PIC 9.
       01  TEMP-EMPNUM             PIC X(6) VALUE SPACES.

       01  RECORD-STATUS-FIELDS.
           05  RECORD-STATUS       PIC XX VALUE '00'.
           05  RECORD-STATUS2 REDEFINES RECORD-STATUS.
               10  STATUS1         PIC X.
               10  STATUS2         PIC 9.
           05  OUTFILE-STATUS      PIC 999.

       PROCEDURE DIVISION.

           DISPLAY "-----------------------------------------------"
           DISPLAY "*      Sample for KSDS VT Facility            *"
           DISPLAY "*  It uses Employee Management sample files   *"
           DISPLAY "*  This sample will browse all the records    *"
           DISPLAY "-----------------------------------------------"


      **************************************************************
      *           OPEN THE KSDS FILE FOR BROWSE                    *
      **************************************************************

              MOVE 'FALS' TO EOF-INDICATOR
              PERFORM OPEN-BROWSE-FILE
              PERFORM BROWSE-FILE UNTIL EOF-INDICATOR = 'TRUE'
              GO TO CLOSE-FILE.


       OPEN-BROWSE-FILE.
           OPEN INPUT RECORD-FILE.
           IF RECORD-STATUS NOT = '00'
               DISPLAY 'FAILED TO OPEN KSDS FILE, Status = '
                RECORD-STATUS
                GO TO RETURN-LABEL.
           IF STATUS1 = '9'
               DISPLAY 'FAILED TO OPEN KSDS FILE, Status = '
                RECORD-STATUS
                GO TO RETURN-LABEL.

      **************************************************************
      *           BROWSE THE KSDS FILE                             *
      **************************************************************

       BROWSE-FILE.
           READ RECORD-FILE
                AT END
                MOVE 'TRUE' TO EOF-INDICATOR.
           IF EOF-INDICATOR NOT EQUAL TO 'TRUE'

           PERFORM VARYING SUB FROM 1 BY 1 UNTIL SUB > 6
           IF ( ENUMB(SUB:1) > '0' )
               SUBTRACT SUB FROM 7 GIVING REMAINING-DIGITS
               MOVE ENUMB(SUB:REMAINING-DIGITS) TO TEMP-EMPNUM
               MOVE 7 TO SUB
           END-IF
           IF (ENUMB(SUB:1) = '0' )
                 MOVE ' ' TO ENUMB(SUB:1)
           END-IF
           END-PERFORM

             DISPLAY 'Employee Number : ' TEMP-EMPNUM
             DISPLAY 'Name            : ' ENAMEX
             DISPLAY 'Address         : ' EADDRX
             DISPLAY 'Phone           : ' EPHONE
             DISPLAY 'Date            : ' EDATEX
             DISPLAY 'Amount          : ' EAMOUNT
             DISPLAY 'Comment         : ' ECOMMENT
             DISPLAY "-----------------------------------------------"
             ADD 1 TO REC-COUNTER
           END-IF.

      **************************************************************
      *           CLOSE THE FILE BEFORE RETURN                     *
      **************************************************************
       CLOSE-FILE.
              IF REC-COUNTER  = 0
                 DISPLAY "NO RECORDS FOUND IN KSDS FILE CICS.DFHCFIL"
              END-IF.
              CLOSE RECORD-FILE.
              GO TO RETURN-LABEL.

       RETURN-LABEL.
              GOBACK.

