# VERSION : 1.1 
# DATE    : 11/08/09 
# COPYRIGHT:
#                                                         
#   (C) COPYRIGHT International Business Machines Corp.   
#   2011                                            
#   All Rights Reserved                                   
#   Licensed Materials - Property of IBM                  
#   5725-C89                                              
#                                                         
#   US Government Users Restricted Rights -               
#   Use, duplication or disclosure restricted by          
#   GSA ADP Schedule Contract with IBM Corp.              
#                                                         
#                                                                       
#            NOTICE TO USERS OF THE SOURCE CODE EXAMPLES                
#                                                                       
# INTERNATIONAL BUSINESS MACHINES CORPORATION PROVIDES THE SOURCE CODE  
# EXAMPLES, BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS, AS IS          
# WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,            
# INCLUDING, BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF               
# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE     
# RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE CODE EXAMPLES,   
# BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS, IS WITH YOU.  SHOULD     
# ANY PART OF THE SOURCE CODE EXAMPLES PROVE DEFECTIVE, YOU (AND NOT    
# IBM) ASSUME THE ENTIRE COST OF ALL NECESSARY SERVICING, REPAIR OR     
# CORRECTION.  THIS PROGRAM MAY BE USED, EXECUTED, COPIED, MODIFIED     
# AND DISTRIBUTED WITHOUT ROYALTY FOR THE PURPOSE OF DEVELOPING,        
# MARKETING, OR DISTRIBUTING.                                           
#                                                                       
#                                                                       
#
#-----------------------------------------------------------------------------
# This is a sample Jython script which demonstrates the usage of WXTR wsadmin
# command in a Jython script.
# Usage:
# wsadmin.sh -lang jython -host_name <hostname> -port_number <portnumber> -userid <userid> -password <password> -f sample.py -cell <cellname> -node <nodename> -server <servername>
#-----------------------------------------------------------------------------

import sys

#------------------------------------------------------------------------------
# runWXTRCommand
# Executes 'get' on the resource class "rd" and prints the parameter name, value list
# You can try modifying the command and entering some invalid value and see the
# control going to exception block.
#------------------------------------------------------------------------------
def runWXTRCommand(cell, node, server):
	try:
		print "Executing wsadmin command to fetch the parameter values of 'rd' resource class"
	        print AdminTask.cics('[-command get -nodeName ' + node + ' -serverName ' + server + ' -c rd]')
	except:
	        print 'Error: ', sys.exc_info()[0], sys.exc_info()[1]
		return 1
	return 0


#------------------------------------------------------------------------------
# Main entry point
#------------------------------------------------------------------------------

cell = None
node = None
server = None

# Try to get a node, cell, and server from command-line arguments
i = 0
while i < len(sys.argv):
        if sys.argv[i] == "-server":
        	server = sys.argv[i + 1]
        	i = i + 1
        elif sys.argv[i] == "-node":
        	node = sys.argv[i + 1]
        	i = i + 1
        elif sys.argv[i] == "-cell":
        	cell = sys.argv[i + 1]
        	i = i + 1
        i = i + 1


if cell == None:
        print "Please specify a cell with the \'-cell\' option."
        sys.exit(100)
elif node == None:
        print "Please specify a node with the \'-node\' option."
        sys.exit(101)
elif server == None:
        print "Please specify a server with the \'-server\' option."
        sys.exit(102)

if server != None and cell != None and node != None:
	retVal = runWXTRCommand(cell, node, server)
        if retVal == 0:
        	print "Successfully executed the script."
        else:
		print "Command execution failed, exiting with return value 105"
        	sys.exit(105)
else:
	print "Please specify cell, node and server names."

